<!DOCTYPE html>
<html>
<head>
<title>EL raton y el gato</title>
</head>
<script type="text/javascript">

var x = "";
var gameOver = false;

//camino
let camino = new Array(59);

//dados
const dados = () => Math.floor(Math.random() * 6) + 1;

//object raton y gato
let raton = {
	id: 'raton',
	posicionIni: 29,
	posicion: 29,
	tirarDado: () => dados(),
}

let gato = {
	id: 'gato',
	posicionIni: 59,
	posicion: 59,
	tirarDado: () => dados(),
}


// si gato tira el dado y encuentra ratom, gato gana
// si ratom tira el dado y encuentra gato, ratom gana
const isEmpty = (pos, camino) => {
	if(camino[pos] == null){
		alert("vacio");
		return true;
	}else{
		return false;
	}
}

// const tiraRaton = (dado, pos, camino) => isEmpty(pos, camino);

const ratonTiraDado = (camino, raton) => {
	var dado = raton.tirarDado();
		
		if(dado + raton.posicion > 60){
			
			raton.posicion = raton.posicionIni;
		
		}
		else{
			
			raton.posicion = dado + raton.posicion;

			if(isEmpty(raton.posicion, camino) == true){
				console.log("Raton: He tirado un " + dado + " voy a la casilla " + raton.posicion)
				camino[raton.posicion] = raton;
			}
			else{
				console.log("Raton: He ganado!!!");
				return true;
			}
		
		}
		return false;

}


const gatoTiraDado = (camino, gato) => {
 var dado = gato.tirarDado();
	if((dado * 2) - gato.posicion < 0){
		gato.posicion = gato.posicionIni;
	}
	else{
	gato.posicion = (dado * 2) - gato.posicion;

		if(isEmpty(gato.posicion, camino)){
			console.log("Gato: He tirado un " + dado + " voy a la casilla " + gato.posicion)
			camino[gato.posicion] = gato;
		}
		else{
			console.log("Gato: He ganado!!!");
			return true;
		}
	}
	return false;

}


const gameStart = () => {
//le paso la posicion inicial del raton y el gato
camino[raton.posicionIni] = raton;
camino[gato.posicionIni] = gato;

//siempre tira primero los dados el raton
	while(gameOver === false){
		if(ratonTiraDado(camino, raton)){
			gameOver = true;	
		}

		if(gatoTiraDado(camino, raton)){
			gameOver = true;
		}
		
	}


}


</script>

<body>




var answer = isUserValid(true) ? "you may enter" : "Access Denied";


</body>
</html>